transformers-0.4.1.0: Concrete functor and monad transformers

Portability | portable
Stability | experimental
Maintainer | ross@soi.city.ac.uk
Safe Haskell | Safe-Inferred

Control.Monad.Trans.List

Contents

- The ListT monad transformer
- Lifting other operations

Description

The ListT monad transformer, adding backtracking to a given monad, which must be commutative.

Synopsis

- newtype ListT m a = ListT {
  - runListT :: m [a]
  }
- mapListT :: (m [a] -> n [b]) -> ListT m a -> ListT n b
- liftCallCC :: CallCC m [a] [b] -> CallCC (ListT m) a b
- liftCatch :: Catch e m [a] -> Catch e (ListT m) a

# The ListT monad transformer

newtype ListT m a

Parameterizable list monad, with an inner monad.

Note: this does not yield a monad unless the argument monad is commutative.

Constructors

ListT |

Fields

runListT :: m [a]

Instances

MonadTrans ListT |
Monad m => Monad (ListT m) |
Functor m => Functor (ListT m) |
Monad m => MonadPlus (ListT m) |
Applicative m => Applicative (ListT m) |
Foldable f => Foldable (ListT f) |
Traversable f => Traversable (ListT f) |
Applicative m => Alternative (ListT m) |
MonadIO m => MonadIO (ListT m) |
Show1 m => Show1 (ListT m) |
Read1 m => Read1 (ListT m) |
Ord1 m => Ord1 (ListT m) |
Eq1 m => Eq1 (ListT m) |
(Eq1 m, Eq a) => Eq (ListT m a) |
(Ord1 m, Ord a) => Ord (ListT m a) |
(Read1 m, Read a) => Read (ListT m a) |
(Show1 m, Show a) => Show (ListT m a) |

mapListT :: (m [a] -> n [b]) -> ListT m a -> ListT n b

Map between `ListT` computations.

-     runListT (mapListT f m) = f (runListT m)

# Lifting other operations

liftCallCC :: CallCC m [a] [b] -> CallCC (ListT m) a b

Lift a `callCC` operation to the new monad.

liftCatch :: Catch e m [a] -> Catch e (ListT m) a

Lift a `catchE` operation to the new monad.